create table FK_S_DOKUMENTY ( /* SOWNIK TYPW DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator typu dokumentu */
KOD VARCHAR(15), /* kod typu dokumentu - wykorzystywany w numerze dokumentu */
NAZWA VARCHAR(250), /* nazwa typu dokumentu */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis typu dokumentu wraz z podpowiedzi do dodatkowych pl */
PRZEPLYW VARCHAR(4), /* moliwe przepywy dokumentw (DWPR) */
ID_S_POZIOMY INTEGER, /* identyfikator poziomu dokumentu (plan, wniosek, zaangaowanie, zobowizanie, realizacja) */
CZY_SAMODZIELNY CHAR(1), /* T - dokument tego typu moe wystpowa bez dokumentu nadrzdnego */
CZY_RATY CHAR(1), /* T - dla dokumentu wspomagane jest wyliczanie rat */
CZY_MENU CHAR(1), /* T - typ dokumentu znajduje si w gwnym menu programu */
ZAANGAZOWANIE CHAR(2), /* WN/MA/-- - strona, po ktrej dokument jest ksigowany w zaangaowaniu (998, 999) */
PRIMARY KEY (ID))

create table FK_S_PODTYPY ( /* SOWNIK PODTYPW DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator podtypu dokumentu */
ID_S_DOKUMENTY INTEGER NOT NULL, /* identyfikator typu dokumentu dla danego podtypu */
KOD VARCHAR(15), /* kod podtypu dokumentu - wykorzystywany w numerze dokumentu */
NAZWA VARCHAR(250), /* nazwa podtypu dokumentu */
PRIMARY KEY (ID))

create table FK_S_POZIOMY ( /* SOWNIK POZIOMW DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator poziomu typu dokumentu */
KOD VARCHAR(15), /* kod poziomu dokumentu */
NAZWA VARCHAR(250), /* nazwa poziomu dokumentu */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis poziomu dokumentu */
PRIMARY KEY (ID))

create table FK_S_POZYCJE ( /* SOWNIK DODATKOWYCH PL W TYPIE DOKUMENTU */
ID INTEGER NOT NULL, /* unikalny identyfikator pola dokumentu */
ID_S_DOKUMENTY INTEGER NOT NULL, /* identyfikator typu dokumentu dla danego pola */
KOD VARCHAR(15), /* kod pola dokumentu (powinien by unikalny w ramach typu dokumentu) */
NAZWA VARCHAR(250), /* nazwa pola dokumentu */
TYP_DANYCH INTEGER NOT NULL, /* typ danych pola dokumentu */
PRIMARY KEY (ID))

create table FK_S_POZYCJE_ENUM ( /* SOWNIK WARTOCI POLA Z LIST WARTOCI */
ID INTEGER NOT NULL, /* unikalny identyfikator wartoci pola */
ID_S_POZYCJE INTEGER NOT NULL, /* identyfikator pola typu dokumentu */
VAL_INT INTEGER NOT NULL, /* warto liczbowa ukryta za tekstem */
VAL_STR VARCHAR(250), /* warto teksowa pola */
PRIMARY KEY (ID))

create table FK_S_DOK_TREE ( /* SOWNIK HIERARCHII DOKUMENTW */
ID_PARENT INTEGER NOT NULL, /* identyfikator typu dokumentu nadrzdnego */
ID_CHILD INTEGER NOT NULL, /* identyfikator typu dokumentu podrzdnego */
PRIMARY KEY (ID_PARENT, ID_CHILD))

create table FK_S_TYPY_DANYCH ( /* SOWNIK TYPW DANYCH */
ID INTEGER NOT NULL, /* unikalny identyfikator typu danych */
KOD VARCHAR(15), /* kod typu danych, okrelajcy pole tabeli */
NAZWA VARCHAR(15), /* nazwa typu danych */
PRIMARY KEY (ID))

create table FK_S_BOOLEAN ( /* SOWNIK WARTOCI LOGICZNYCH */
ID CHAR(1) NOT NULL, /* unikalny jednoznakowy identyfikator wartoci logicznej */
NAZWA VARCHAR(10), /* nazwa wartoci logicznej */
PRIMARY KEY (ID))

create table FK_S_ETYKIETY ( /* SOWNIK ETYKIET (POST-IT) */
ID INTEGER NOT NULL, /* unikalny identyfikator etykiety */
KOD VARCHAR(15), /* kod etykiety (wywietlany, gdy etykiety po przecinku) */
NAZWA VARCHAR(250), /* nazwa etykiety (wywietlana na licie etykiet) */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis etykiety */
PRIMARY KEY (ID))

create table FK_ETYKIETY ( /* PRZYPORZDKOWANIE ETYKIET DO DOKUMENTW */
ID_S_ETYKIETY INTEGER NOT NULL, /* identyfikator etykiety ze sownika etykiet */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator dokumentu */
PRIMARY KEY (ID_S_ETYKIETY, ID_DOKUMENTY))

create table FK_S_STATUSY ( /* SOWNIK STATUSW DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator statusu dokumentu */
NAZWA VARCHAR(20), /* nazwa statusu */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis statusu */
CZY_WIDOCZNY CHAR(1), /* czy status domylnie widoczny */
CZY_EDYCJA_DOK CHAR(1), /* czy dozwolona edycja podstawowych danych o dokumencie */
CZY_EDYCJA_KWOT CHAR(1), /* czy dozwolona edycja kwot i terminw patnoci */
CZY_EDYCJA_DEKR CHAR(1), /* czy dozwolona edycja dekretacji kwot */
CZY_EDYCJA_ZAANG CHAR(1), /* czy dozwolona edycja zaangaowania */
CZY_EDYCJA_KSIE CHAR(1), /* czy dozwolona edycja ksigowania */
CZY_ZATWIERDZONY CHAR(1), /* czy status oznacza dokument ostatecznie zatwierdzony */
CZY_USUNIETY CHAR(1), /* czy status oznacza dokument usunity (archiwalny, odrzucony) */
PRIMARY KEY (ID))

create table FK_S_STATUS_TREE ( /* SOWNIK OPERACJI NA STATUSACH */
ID_FROM INTEGER NOT NULL, /* identyfikator statusu wyjciowego */
ID_TO INTEGER NOT NULL, /* identyfikator statusu ustawianego */
NAZWA VARCHAR(20), /* nazwa operacji */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis operacji */
POTWIERDZENIE BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* pytanie o potwierdzenie zmiany statusu */
PRIMARY KEY (ID_FROM, ID_TO))

create table FK_STATUSY ( /* HISTORIA ZMIAN STATUSW DOKUMENTW */
ID_S_STATUSY INTEGER NOT NULL, /* identyfikator statusu ze sownika statusw */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator dokumentu, ktrego dotyczy status */
ID_UZYTKOWNIK INTEGER, /* identyfikator uytkownika, ktry dokona zmiany statusu */
CZAS_STATUSU TIMESTAMP /* data i godzina ustawienia statusu */
)

create table FK_DOKUMENTY ( /* DOKUMENTY */
ID INTEGER NOT NULL, /* unikalny identyfikator dokumentu */
ID_PIERWOTNY INTEGER NOT NULL, /* identyfikator pierwotnej wersji dokumentu */
ID_S_DOKUMENTY INTEGER NOT NULL, /* identyfikator typu dokumentu ze sownika */
ID_S_PODTYPY INTEGER, /* identyfikator podtypu dokumentu ze sownika */
ID_JB INTEGER NOT NULL, /* identyfikator jednostki, ktrej dotyczy dokument */
ID_KONTRAHENCI INTEGER, /* identyfikator kontrahenta (ze sownika kontrahentw poczonego ze sownikiem jednostek) */
ID_PARENT INTEGER, /* identyfikator dokumentu nadrzdnego */
NUMER VARCHAR(250), /* unikalny w ramach jednostki numer dokumentu */
DATA_DOK DATE, /* data podpisania/wystawienia dokumentu (na ten dzie ustalany plan dla sprawdzenia poprawnoci) */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis dokumentu */
WERSJA INTEGER NOT NULL, /* numer wersji dokumentu: 0 - pierwotna, 1..n - aneks */
STATUS INTEGER, /* obecny status dokumentu (domylnie 0) */
PRIMARY KEY (ID))

create table FK_POZYCJE ( /* DODATKOWE POLA DOKUMENTU */
ID INTEGER NOT NULL, /* unikalny identyfikator pola dokumentu */
ID_S_POZYCJE INTEGER NOT NULL, /* identyfikator pola typu dokumentu ze sownika pl */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator dokumentu, ktrego dotyczy pole */
VAL_INT INTEGER, /* warto liczbowa pola */
VAL_STR VARCHAR(250), /* warto tekstowa pola */
VAL_DATE TIMESTAMP, /* warto daty pola */
PRIMARY KEY (ID))

create table FK_PLIKI ( /* PLIKI DOCZONE DO DOKUMENTU */
ID INTEGER NOT NULL, /* unikalny identyfikator pliku */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator wersji pierwotnej dokumentu, ktrego dotyczy plik */
ID_PLIKI INTEGER NOT NULL, /* identyfikator w bazie plikw */
NAZWA VARCHAR(250), /* nazwa pliku */
TYP VARCHAR(15), /* rozszerzenie pliku */
POZYCJA INTEGER NOT NULL, /* liczba porzdkowa pliku dla dokumentu */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis pliku */
PRIMARY KEY (ID))

create table FK_TERMINY ( /* KWOTY I TERMINY PATNOCI DLA DOKUMENTU */
ID INTEGER NOT NULL, /* unikalny identyfikator terminu patnoci */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator dokumentu, ktrego dotyczy termin patnoci */
TERMIN DATE, /* termin patnoci */
KWOTA DOUBLE PRECISION, /* kwota patnoci */
PRIMARY KEY (ID))

create table FK_DEKRETACJA ( /* DEKRETACJA KWOT DLA TERMINW PATNOCI DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator pozycji w dekretacji */
ID_TERMINY INTEGER NOT NULL, /* identyfikator terminu patnoci */
ID_ZADANIA INTEGER, /* identyfikator zadania */
DZIAL CHAR(3), /* dzia */
ROZDZIAL CHAR(5), /* rozdzia */
PAR CHAR(3), /* paragraf (cyfry 1-3) */
PAR4 CHAR(1), /* paragaf (4. cyfra) */
KWOTA DOUBLE PRECISION, /* kwota */
PRIMARY KEY (ID))

create trigger TRIG_FK_S_DOKUMENTY for FK_S_DOKUMENTY
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_S_PODTYPY for FK_S_PODTYPY
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_S_POZYCJE for FK_S_POZYCJE
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_S_POZYCJE_ENUM for FK_S_POZYCJE_ENUM
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_S_ETYKIETY for FK_S_ETYKIETY
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_DOKUMENTY for FK_DOKUMENTY
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_POZYCJE for FK_POZYCJE
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_PLIKI for FK_PLIKI
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_TERMINY for FK_TERMINY
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_DEKRETACJA for FK_DEKRETACJA
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

insert into FK_S_POZIOMY (ID, KOD, NAZWA, OPIS)
values (-1, 'PLAN', 'Plan', 'Na tym poziomie dochodzi do planowania budetu.')

insert into FK_S_POZIOMY (ID, KOD, NAZWA, OPIS)
values (0, 'WNIOSEK', 'Wnioskowanie', 'Na tym poziomie dochodzi do wnioskowania o przyznanie rodkw.')

insert into FK_S_POZIOMY (ID, KOD, NAZWA, OPIS)
values (1, 'ZAANGAZOWANIE', 'Zaangaowanie', 'Na tym poziomie dochodzi do blokowania rodkw.')

insert into FK_S_POZIOMY (ID, KOD, NAZWA, OPIS)
values (2, 'ZOBOWIAZANIE', 'Zobowizanie', 'Na tym poziomie dochodzi do powstania zobowiza.')

insert into FK_S_POZIOMY (ID, KOD, NAZWA, OPIS)
values (3, 'REALIZACJA', 'Realizacja', 'Na tym poziomie dochodzi do realizacji zobowiza.')

insert into FK_S_TYPY_DANYCH (ID, KOD, NAZWA) values (0, 'VAL_INT', 'liczba')

insert into FK_S_TYPY_DANYCH (ID, KOD, NAZWA) values (1, 'VAL_STR', 'tekst')

insert into FK_S_TYPY_DANYCH (ID, KOD, NAZWA) values (2, 'VAL_DATE', 'data')

insert into FK_S_TYPY_DANYCH (ID, KOD, NAZWA) values (3, 'ENUM', 'lista wartoci')

insert into FK_S_BOOLEAN (ID, NAZWA) values ('T', 'Tak')

insert into FK_S_BOOLEAN (ID, NAZWA) values ('N', 'Nie')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (0, 'otwarty', 'Dokument jest otwarty do edycji.',
'T', 'T', 'T', 'T', 'N', 'N', 'N', 'N')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (1, 'zaakceptowany', 'Dokument jest zaakceptowany i moe zosta zaangaowany i zaksigowany.',
'T', 'T', 'N', 'N', 'T', 'T', 'N', 'N')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (2, 'zamknity', 'Dokument jest zamknity. Aby wprowadzi zmiany, naley utworzy korekt.',
'T', 'N', 'N', 'N', 'N', 'N', 'T', 'N')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (3, 'wniosek', 'Wysany zosta wniosek o zaakceptowanie dokumentu.',
'T', 'N', 'N', 'N', 'N', 'N', 'N', 'N')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (4, 'poprawiany', 'Dokument zosta odesany do ponownej edycji.',
'T', 'T', 'T', 'T', 'N', 'N', 'N', 'N')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (5, 'odrzucony', 'Wniosek o zaakceptowanie dokumentu zosta rozpatrzony negatywnie.',
'N', 'N', 'N', 'N', 'N', 'N', 'N', 'T')

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (6, 'archiwalny', 'Dokument zosta przeniesiony do archiwum.',
'N', 'N', 'N', 'N', 'N', 'N', 'N', 'T')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (0, 1, 'Akceptuj',
'Akceptuj dokument i przejd do jego angaowania i ksigowania',
'Czy na pewno chcesz zaakceptowa ten dokument bez wysyania wniosku? Ta operacja jest nieodwracalna.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (1, 2, 'Zatwierd',
'Ostatecznie zatwierd dokument',
'Czy na pewno chcesz zatwierdzi ten dokument? Aby zmieni dane trzeba bdzie utworzy aneks.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (0, 3, 'Wnioskuj',
'Wnioskuj o zaakceptowanie dokumentu',
'Czy na pewno chcesz wysa wniosek o zaakceptowanie tego dokumentu?')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (4, 3, 'Wnioskuj',
'Wnioskuj o zaakceptowanie dokumentu',
'Czy na pewno chcesz wysa wniosek o zaakceptowanie tego dokumentu?')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (3, 1, 'Akceptuj',
'Akceptuj dokument i przejd do jego angaowania i ksigowania',
'Czy na pewno chcesz zaakceptowa ten dokument? Ta operacja jest nieodwracalna.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (3, 4, 'Popraw',
'Odrzu wniosek o dokument i przelij do poprawy',
'Czy na pewno chcesz odesa ten dokument do poprawy?')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (3, 5, 'Odrzu',
'Ostatecznie odrzu wniosek o dokument',
'Czy na pewno chcesz odrzuci wniosek o ten dokument? Ta operacja jest nieodwracalna.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (0, 6, 'Do archiwum',
'Przenie dokument do archiwum',
'Czy na pewno chcesz przenie ten dokument do archiwum? Ta operacja jest nieodwracalna.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (4, 6, 'Do archiwum',
'Przenie dokument do archiwum',
'Czy na pewno chcesz przenie ten dokument do archiwum? Ta operacja jest nieodwracalna.')

create table FK_S_PLAN_KONT ( /* SOWNIK ZAWIERAJCY PLAN KONT BUDETOWYCH */
ID INTEGER NOT NULL, /* unikalny identyfikator konta */
ID_JB INTEGER, /* identyfikator jednostki, ktrej dotyczy konto */
KOD VARCHAR(35), /* kod konta na danym poziomie hierarchii */
NAZWA VARCHAR(250), /* nazwa konta */
KOD_FULL VARCHAR(250), /* peny kod konta, zawierajcy pen ciek do konta */
OPIS BLOB SUB_TYPE 0 SEGMENT SIZE 80, /* opis konta */
ID_PARENT INTEGER, /* identyfikator konta nadrzdnego */
POZIOM INTEGER, /* poziom konta */
CZY_KLAS_B CHAR(1), /* T - okrelona podziaka klasyfikacyjna lub kontrahent */
ID_KONTRAHENCI INTEGER, /* identyfikator kontrahenta */
ID_ZADANIA INTEGER, /* identyfikator zadania */
DZIAL CHAR(3), /* dzia */
ROZDZIAL CHAR(5), /* rozdzia */
PAR CHAR(3), /* paragraf (cyfry 1-3) */
PAR4 CHAR(1), /* paragraf (4. cyfra) */
DATA_OD DATE, /* data rozpoczcia obowizywania konta ??? */
DATA_DO DATE, /* data zakoczenia obowizywania konta ??? */
ROKB INTEGER, /* rok rozliczeniowy, dla ktrego okrelone jest konto */
PRIMARY KEY (ID))

create table FK_SCHEMATY_KSIEGOWANIA ( /* SCHEMATY KSIGOWANIA DLA TYPW DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator pozycji schematu ksigowania */
ID_S_DOKUMENTY INTEGER NOT NULL, /* identyfikator typu dokumentu ze sownika */
KONTO_WN CHAR(3), /* kod konta syntetycznego, dla ktrego ksigowanie zachodzi po stronie WN */
KONTO_MA CHAR(3), /* kod konta syntetycznego, dla ktrego ksigowanie zachodzi po stronie MA */
PRIMARY KEY (ID))

create table FK_KSIEGOWANIA ( /* KSIGOWANIA KWOT DOTYCZCE DOKUMENTW */
ID INTEGER NOT NULL, /* unikalny identyfikator ksigowania */
ID_DOKUMENTY INTEGER NOT NULL, /* identyfikator dokumentu, ktrego dotyczy ksigowanie */
ID_KONTA_WN INTEGER, /* identyfikator konta z planu kont, dla ktrego kwota ksigowana jest po stronie WN */
ID_KONTA_MA INTEGER, /* identyfikator konta z planu kont, dla ktrego kwota ksigowana jest po stronie MA */
DATA_KSIE DATE, /* data ksigowania */
KWOTA DOUBLE PRECISION, /* kwota */
PRIMARY KEY (ID))

create trigger TRIG_FK_S_PLAN_KONT for FK_S_PLAN_KONT
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_SCHEMATY_KSIEGOWANIA for FK_SCHEMATY_KSIEGOWANIA
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

create trigger TRIG_FK_KSIEGOWANIA for FK_KSIEGOWANIA
ACTIVE BEFORE INSERT POSITION 0 AS BEGIN NEW.ID = GEN_ID(GEN_PB,1);
END

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (7, 'korygowany', 'Dokument jest korygowany.',
'T', 'T', 'T', 'T', 'T', 'T', 'N', 'N')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (2, 7, 'Korekta',
'Przeprowad korekt dokumentu',
'Czy na pewno chcesz przeprowadzi korekt dokumentu? Ten dokument zosta ju ostatecznie zatwierdzony.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (7, 2, 'Zatwierd',
'Ostatecznie zatwierd dokument',
'Czy na pewno chcesz zatwierdzi ten dokument? Aby zmieni dane trzeba bdzie utworzy aneks.')

alter table FK_S_DOKUMENTY add FORMULARZ BLOB SUB_TYPE 0 SEGMENT SIZE 80

update FK_DEKRETACJA set ID_ZADANIA = 0 where ID_ZADANIA is null

create view "V_FK_DOK_WIDOCZNE" ( /* OSTATNIA AKTYWNA WERSJA DOKUMENTU */
  "ID_PIERWOTNY", /* identyfikator wersji pierwotnej */
  "WERSJA" /* ostatnia aktywna wersja */
) as
select dok.ID_PIERWOTNY, max(dok.WERSJA)
from FK_DOKUMENTY dok
join FK_S_STATUSY s on dok.STATUS = s.ID
where s.CZY_USUNIETY = 'N'
group by dok.ID_PIERWOTNY

CREATE VIEW V_KONTRAHENCI( /* Kontrahenci*/
    ID,
    KOD,
    TYP,
    SKROT,
    NAZWA,
    MIASTO,
    ULICA,
    PNA,
    POCZTA,
    TEL1,
    TEL2,
    TEL3,
    KONTAKT,
    EMAIL,
    UWAGI,
    REGON,
    REGON2,
    NIP,
    DPOCZ,
    DKON,
    KONTO)
AS
select ID_JB as ID
      ,KOD_JB as KOD
      ,TYP_JB as TYP
      ,SKROT
      ,NAZWA
      ,MIASTO
      ,ULICA
      ,PNA
      ,POCZTA
      ,TEL1
      ,TEL2
      ,TEL3
      ,KONTAKT
      ,EMAIL
      ,UWAGI
      ,REGON
      ,REGON2
      ,NIP
      ,DPOCZ
      ,DKON
      ,KONTO
from PB_S_JB
union
select ID_KONTR as ID
      ,cast(KOD_KONTR as VARCHAR(15) CHARACTER SET WIN1250) as KOD
      ,TYP_KONTR as TYP
      ,SKROT
      ,NAZWA
      ,MIASTO
      ,ULICA
      ,PNA
      ,POCZTA
      ,TEL1
      ,TEL2
      ,TEL3
      ,KONTAKT
      ,EMAIL
      ,UWAGI
      ,REGON
      ,cast(NULL as VARCHAR(5) CHARACTER SET WIN1250) as REGON2
      ,NIP
      ,DPOCZ
      ,DKON
      ,KONTO
from PB_S_KONTR

alter table FK_KSIEGOWANIA add ROK CHAR(4)

alter table FK_DOKUMENTY add KSIAZKA_POD VARCHAR(250)

insert into FK_S_STATUSY (ID, NAZWA, OPIS, CZY_WIDOCZNY, CZY_EDYCJA_DOK, CZY_EDYCJA_KWOT, CZY_EDYCJA_DEKR, CZY_EDYCJA_ZAANG, CZY_EDYCJA_KSIE, CZY_ZATWIERDZONY, CZY_USUNIETY)
values (8, 'tymczasowy', 'Dokument tymczasowy, moliwa zmiana wszystkich danych.',
'T', 'T', 'T', 'T', 'T', 'T', 'N', 'N')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (8, 0, 'Zmie na otwarty',
'Zmie status dokumetu na otwarty',
'Czy na pewno chcesz zmieni status dokumentu? Zmiana typu dokumentu nie bdzie ju moliwa.')

insert into FK_S_STATUS_TREE (ID_FROM, ID_TO, NAZWA, OPIS, POTWIERDZENIE) values (8, 6, 'Do archiwum',
'Przenie dokument do archiwum',
'Czy na pewno chcesz przenie ten dokument do archiwum? Ta operacja jest nieodwracalna.')


commit work
