/*
   ta linia separatora z myslnikami to nie komentarz tylko
   slowo kluczowe skryptu powodujace wykonanie tej czesci skryptu,
   ktora jest nad linia separatora!
   (co oznacza, ze jesli w takim bloku jest blad, to reszta bloku (albo i caly :p)
    do najblizszej linii separatora nie zostanie wykonana)
*/

/* Z.D.2011-04 ad. mantis 897; zawsze dodawalem tylko pojedyncze linie do "oryginalow" z poprzednich update.sql (nie liczac formatowania wciec) */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP (
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    poziom varchar(15),
    typ_pg varchar(1))
as
declare variable id_wyzej integer;
declare variable czesc_realizacja double precision;
declare variable samodzielny char(1);
declare variable czesc_zobowiazanie double precision;
begin
  /* Zwraca zaangazowanie zobowiazanie i realizacje na dany rok */
    for
      select
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
        sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
        sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,sp.KOD as POZIOM,
        zad.TYP_PG as TYP_PG
      from
        FK_DEKRETACJA dekr
        left join PB_ZADANIA zad on (dekr.ID_ZADANIA = zad.ID_ZADANIA
                                     and (:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0)
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
            join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
              join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
            join FK_S_STATUSY sta on (sta.ID=dok.STATUS
                                      and sta.CZY_USUNIETY = 'N'
                                      and (sta.CZY_ZATWIERDZONY = 'T' or :CZY_ZATW = 0) )
            left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
            left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) =:ROK and
        not EXISTS (select
                      d.ID
                    from
                      FK_DOKUMENTY d
                      join FK_S_STATUSY st on (st.ID=d.STATUS)
                    where
                      d.ID_PIERWOTNY=dok.ID_PIERWOTNY
                      and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
                      and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
                      d.DATA_DOK >= :DATAOD and
                      d.DATA_DOK <= :DATADO) and
        (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                               ID_JB
                                             from
                                               GET_JB_FROM_TYP (:TYP_JB) )) and
        dekr.DZIAL = :DZIAL and
        dekr.ROZDZIAL = :ROZDZIAL and
        dekr.PAR = :PAR and
        dekr.PAR4 = :PAR4 and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO
      group by
        dok.numer, dok.data_dok, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
        sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY,sp.KOD, zad.TYP_PG
      order by
        dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM, :TYP_PG

    do
    begin
      ZOBOWIAZANIE=0;
      REALIZACJA=0;

      if (CZY_SAMODZIELNY='T' and POZIOM='ZOBOWIAZANIE') then ZOBOWIAZANIE=:ZAANGAZOWANIE;

      for
        select
          sdok.CZY_SAMODZIELNY, sum(dekr.KWOTA) as ZOBOWIAZANIE,sp.KOD as POZIOM,
          zad.TYP_PG as TYP_PG
        from
          FK_DEKRETACJA dekr
          left join PB_ZADANIA zad on (dekr.ID_ZADANIA = zad.ID_ZADANIA
                                       and (:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0)
          join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
            join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
              join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
                join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
              inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and sta.CZY_USUNIETY='N'
                                              and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
        where
          extract(year from dok.DATA_DOK) = :ROK and
          extract(year from ter.TERMIN) = :ROK and
          (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                                 ID_JB
                                               from
                                                 GET_JB_FROM_TYP (:TYP_JB))) and
          dekr.DZIAL = :DZIAL and
          dekr.ROZDZIAL = :ROZDZIAL and
          dekr.PAR = :PAR and
          dekr.PAR4 = :PAR4 and
          dok.DATA_DOK >= :DATAOD and
          dok.DATA_DOK <= :DATADO and
          dok.ID_PARENT=:ID_PARENT
        group by
          sdok.CZY_SAMODZIELNY, dok.ID_PARENT, sp.KOD, zad.TYP_PG

      into :SAMODZIELNY, :CZESC_ZOBOWIAZANIE, :POZIOM, :TYP_PG
      do
      begin
          if (SAMODZIELNY='N' and POZIOM='ZOBOWIAZANIE') then
            ZOBOWIAZANIE= :ZOBOWIAZANIE+ :CZESC_ZOBOWIAZANIE;
          if (SAMODZIELNY='N' and POZIOM='REALIZACJA') then
            REALIZACJA= REALIZACJA+ :CZESC_ZOBOWIAZANIE;
      end

      for
        select distinct
          dok.ID_PIERWOTNY
        from
          FK_DEKRETACJA dekr
          join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
            join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
              join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
                join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
              inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and sta.CZY_USUNIETY='N'
                                              and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
        where
          extract(year from dok.DATA_DOK) = :ROK and
          extract(year from ter.TERMIN) = :ROK and
          (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                                 ID_JB
                                               from
                                                 GET_JB_FROM_TYP (:TYP_JB))) and
          dekr.DZIAL = :DZIAL and
          dekr.ROZDZIAL = :ROZDZIAL and
          dekr.PAR = :PAR and
          dekr.PAR4 = :PAR4 and
          dok.DATA_DOK >= :DATAOD and
          dok.DATA_DOK <= :DATADO and
          dok.ID_PARENT=:ID_PARENT

      into :ID_WYZEJ
      do
      begin
        select
          sum(rdk.KWOTA)
        from
          FK_DOKUMENTY  rdok
          join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
            join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
          join FK_S_STATUSY sta on (sta.ID=rdok.STATUS and sta.CZY_USUNIETY='N'
                                    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
          join FK_S_DOKUMENTY sdok on rdok.ID_S_DOKUMENTY = sdok.ID
            join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
        where
          rdok.ID_PARENT=:ID_WYZEJ and
          extract(year from rt.TERMIN) =:ROK
          and sp.KOD='REALIZACJA'
          and rdk.DZIAL=:DZIAL
          and rdk.ROZDZIAL=:ROZDZIAL
          and rdk.PAR=:PAR
          and rdk.PAR4=:PAR4

        into :CZESC_REALIZACJA;

        if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;
        REALIZACJA=:CZESC_REALIZACJA+:REALIZACJA;
      end
      suspend;

    end
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ (
    id_zadania integer,
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    poziom varchar(15))
as
declare variable id_wyzej integer;
declare variable czesc_realizacja double precision;
declare variable samodzielny char(1);
declare variable czesc_zobowiazanie double precision;
begin
  /* Zwraca zaangazowanie zobowiazanie i realizacje na dany rok */
    for
      select
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
        sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
        sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,sp.KOD as POZIOM
      from
        FK_DEKRETACJA dekr
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
            join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
              join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
            join FK_S_STATUSY sta on (sta.ID=dok.STATUS
                                      and sta.CZY_USUNIETY = 'N'
                                      and (sta.CZY_ZATWIERDZONY = 'T' or :CZY_ZATW = 0) )
            left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
            left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) =:ROK and
        not EXISTS (select
                      d.ID
                    from
                      FK_DOKUMENTY d
                      join FK_S_STATUSY st on (st.ID=d.STATUS)
                    where
                      d.ID_PIERWOTNY=dok.ID_PIERWOTNY
                      and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
                      and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
                      d.DATA_DOK >= :DATAOD and
                      d.DATA_DOK <= :DATADO) and
        (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB) )) and
        dekr.DZIAL = :DZIAL and
        dekr.ROZDZIAL = :ROZDZIAL and
        dekr.PAR = :PAR and
        dekr.PAR4 = :PAR4 and
        dekr.ID_ZADANIA =:ID_ZADANIA and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO
      group by
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
        sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY, sp.KOD
      order by
        dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY,  :POZIOM

    do
    begin
      ZOBOWIAZANIE=0;
      REALIZACJA=0;
    
      if (CZY_SAMODZIELNY='T' and POZIOM='ZOBOWIAZANIE') then ZOBOWIAZANIE=:ZAANGAZOWANIE;

      for
        select
          sdok.CZY_SAMODZIELNY, sum(dekr.KWOTA) as ZOBOWIAZANIE, sp.KOD as POZIOM
        from
          FK_DEKRETACJA dekr
          join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
            join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
              join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
                join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
              inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and sta.CZY_USUNIETY='N'
                                              and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
        where
          extract(year from dok.DATA_DOK) = :ROK and
          extract(year from ter.TERMIN) = :ROK and
          (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                                 ID_JB
                                               from
                                                 GET_JB_FROM_TYP (:TYP_JB))) and
          dekr.DZIAL = :DZIAL and
          dekr.ROZDZIAL = :ROZDZIAL and
          dekr.PAR = :PAR and
          dekr.PAR4 = :PAR4 and
          dekr.ID_ZADANIA =:ID_ZADANIA and
          dok.DATA_DOK >= :DATAOD and
          dok.DATA_DOK <= :DATADO and
          dok.ID_PARENT=:ID_PARENT
        group by
          sdok.CZY_SAMODZIELNY, dok.ID_PARENT, sp.KOD

      into :SAMODZIELNY, :CZESC_ZOBOWIAZANIE, :POZIOM
      do
      begin
          if (SAMODZIELNY='N' and POZIOM='ZOBOWIAZANIE') then
             ZOBOWIAZANIE= :ZOBOWIAZANIE+ :CZESC_ZOBOWIAZANIE;
          if (SAMODZIELNY='N' and POZIOM='REALIZACJA') then
             REALIZACJA= REALIZACJA+ :CZESC_ZOBOWIAZANIE;
      end

      for
        select distinct
          dok.ID_PIERWOTNY
        from
          FK_DEKRETACJA dekr
          join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
            join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
              join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
                join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
              inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and sta.CZY_USUNIETY='N'
                                              and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
        where
          extract(year from dok.DATA_DOK) = :ROK and
          extract(year from ter.TERMIN) = :ROK and
          (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                                 ID_JB
                                               from
                                                 GET_JB_FROM_TYP (:TYP_JB))) and
          dekr.DZIAL = :DZIAL and
          dekr.ROZDZIAL = :ROZDZIAL and
          dekr.PAR = :PAR and
          dekr.PAR4 = :PAR4 and
          dekr.ID_ZADANIA =:ID_ZADANIA and
          dok.DATA_DOK >= :DATAOD and
          dok.DATA_DOK <= :DATADO and
          dok.ID_PARENT=:ID_PARENT

      into :ID_WYZEJ
      do
      begin
        select
          sum(rdk.KWOTA)
        from
          FK_DOKUMENTY  rdok
          join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
            join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
          join FK_S_STATUSY sta on (sta.ID=rdok.STATUS and sta.CZY_USUNIETY='N'
                                    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
          join FK_S_DOKUMENTY sdok on rdok.ID_S_DOKUMENTY = sdok.ID
            join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
        where
          rdok.ID_PARENT=:ID_WYZEJ
          and extract(year from rt.TERMIN) =:ROK
          and sp.KOD='REALIZACJA'
          and rdk.DZIAL=:DZIAL
          and rdk.ROZDZIAL=:ROZDZIAL
          and rdk.PAR=:PAR
          and rdk.PAR4=:PAR4
          and rdk.ID_ZADANIA=:ID_ZADANIA

        into :CZESC_REALIZACJA;

        if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;
        REALIZACJA=:CZESC_REALIZACJA+:REALIZACJA;
      end
      suspend;

    end
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ TO SYSDBA;

/*--------------------------------------------------------------- */

/* Z.D.2011-04 ad. mantis 897 */

DROP PROCEDURE GET_ZAANGAZOWANIE;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE (
    id_zadania integer,
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    realizacja double precision,
    zaangazowanie double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1))
as
begin
  /* Zwraca zaangazowanie i realizacje na dany rok */
    for
      select
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
        sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
        sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY
      from
        FK_DEKRETACJA dekr
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
            join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
            join FK_S_STATUSY sta on (sta.ID=dok.STATUS
                                      and sta.CZY_USUNIETY = 'N'
                                      and (sta.CZY_ZATWIERDZONY = 'T' or :CZY_ZATW = 0) )
            left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
            left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) =:ROK and
        not EXISTS (select
                      d.ID
                    from
                      FK_DOKUMENTY d
                      join FK_S_STATUSY st on (st.ID=d.STATUS)
                    where
                      d.ID_PIERWOTNY=dok.ID_PIERWOTNY and
                      d.WERSJA>dok.WERSJA and
                      st.CZY_USUNIETY='N' and
                      (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
                      d.DATA_DOK >= :DATAOD and
                      d.DATA_DOK <= :DATADO) and
        (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                               ID_JB
                                             from
                                               GET_JB_FROM_TYP (:TYP_JB) )) and
        dekr.DZIAL = :DZIAL and
        dekr.ROZDZIAL = :ROZDZIAL and
        dekr.PAR = :PAR and
        dekr.PAR4 = :PAR4 and
        dekr.ID_ZADANIA = :ID_ZADANIA and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO
      group by
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT, sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY
      order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY
    do
    begin
      REALIZACJA=0;
      select
        sum(dekr.KWOTA) as REALIZACJA
      from
        FK_DEKRETACJA dekr
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
            join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
              join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
            inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and
                                            sta.CZY_USUNIETY='N' and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) = :ROK and
        sp.KOD='REALIZACJA' and
        (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
        dekr.DZIAL = :DZIAL and
        dekr.ROZDZIAL = :ROZDZIAL and
        dekr.PAR = :PAR and
        dekr.PAR4 = :PAR4 and
        dekr.ID_ZADANIA =:ID_ZADANIA and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO  and
        dok.ID_PARENT=:ID_PARENT
      group by
        dok.ID_PARENT
        
      into :REALIZACJA;

      suspend;
    end
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE_DRP_GP (
    par4_in varchar(1),
    par_in varchar(3),
    rozdzial_in varchar(5),
    dzial_in varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    realizacja double precision,
    zaangazowanie double precision,
    data_dok date,
    numer varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    typ_pg char(1))
as
begin
  /* Zwraca zaangazowanie i realizacje na dany rok */
    DZIAL=:DZIAL_IN;
    ROZDZIAL=:ROZDZIAL_IN;
    PAR=:PAR_IN;
    PAR4=:PAR4_IN;

    for
      select
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
        sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
        sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,
        zad.TYP_PG as TYP_PG
      from
        FK_DEKRETACJA dekr
        left join PB_ZADANIA zad on (dekr.ID_ZADANIA = zad.ID_ZADANIA
                                     and (:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0)
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
            inner join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
            inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS
                                            and sta.CZY_USUNIETY = 'N'
                                            and (sta.CZY_ZATWIERDZONY = 'T' or :CZY_ZATW = 0) )
            left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
            left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) =:ROK and
        not EXISTS (select
                      d.ID
                    from
                      FK_DOKUMENTY  d
                      join FK_S_STATUSY st on (st.ID=d.STATUS)
                    where
                      d.ID_PIERWOTNY=dok.ID_PIERWOTNY
                      and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
                      and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
                      d.DATA_DOK >= :DATAOD and
                      d.DATA_DOK <= :DATADO) and
        (dok.ID_JB = :ID_JB or dok.ID_JB in (select
                                               ID_JB
                                             from
                                               GET_JB_FROM_TYP (:TYP_JB) )) and
        dekr.DZIAL = :DZIAL_IN and
        dekr.ROZDZIAL = :ROZDZIAL_IN and
        dekr.PAR = :PAR_IN and
        dekr.PAR4 = :PAR4_IN and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO
      group by
        dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
        sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY, zad.TYP_PG
      order by
        dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY, :TYP_PG
    do
    begin
      REALIZACJA=0;
      select
        sum(dekr.KWOTA) as REALIZACJA
      from
        FK_DEKRETACJA dekr
        left join PB_ZADANIA zad on (dekr.ID_ZADANIA = zad.ID_ZADANIA
                                     and (:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0)
        join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
          join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
            join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
              join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
            inner join FK_S_STATUSY sta on (sta.ID=dok.STATUS and sta.CZY_USUNIETY='N'
                                            and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where
        extract(year from dok.DATA_DOK) = :ROK and
        extract(year from ter.TERMIN) = :ROK and
        sp.KOD='REALIZACJA' and
        dekr.DZIAL = :DZIAL and
        dekr.ROZDZIAL = :ROZDZIAL and
        dekr.PAR = :PAR and
        dekr.PAR4 = :PAR4 and
        dok.DATA_DOK >= :DATAOD and
        dok.DATA_DOK <= :DATADO and
        dok.ID_PARENT=:ID_PARENT and
        zad.TYP_PG = :TYP_PG
      group by
        dok.ID_PARENT, zad.TYP_PG
        
      into :REALIZACJA;

      suspend;
    end
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_DRP_GP TO SYSDBA;

/*--------------------------------------------------------------- */

/* P.K.2011-04 ad. mantis 902 */

DROP PROCEDURE WYDRUK_RB28;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE WYDRUK_RB28 (
    rokb varchar(4),
    dataod date,
    datado date,
    id_jb integer,
    typ_jb varchar(250))
returns (
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    budzet double precision,
    zaangazowanie double precision,
    realizacja double precision,
    jest_zaangazowanie char(1))
as
declare variable id_wyzej integer;
declare variable id_parent integer;
declare variable czesc_realizacja double precision;
declare variable poziom varchar(15);
begin
  /* Plan budzetowy */
   for select jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4,sum(jp.WARTOSC) as BUDZET
   from
   PB_UCHWALY u
   join PB_BUDZET_J bj on (bj.ID_UCHWALY = u.ID_UCHWALY and bj.STATUS in (0, 9))
   join PB_BUDZET_J_POZ jp on (bj.IDSPRAW = jp.IDSPRAW)
   where
   u.DATA_UOD<=:DATADO and u.ROKB=:ROKB and
   (bj.ID_JB = :ID_JB or bj.ID_JB in (select ID_JB
   from GET_JB_FROM_TYP (:TYP_JB) ))
   and  jp.WARTOSC<>0
   and jp.PRZEPLYW='W'
   group by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   order by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   into
      :DZIAL, :ROZDZIAL,:PAR, :PAR4, :BUDZET
   do
   begin
         /* Zaangazowanie */
         JEST_ZAANGAZOWANIE='N';
         ZAANGAZOWANIE=0;
         REALIZACJA=0;

         select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as ZAANGAZOWANIE
         from FK_DEKRETACJA dekr
         join FK_TERMINY ter
         on (dekr.ID_TERMINY = ter.ID)
         join FK_DOKUMENTY dok on (dok.ID=ter.ID_DOKUMENTY)
         join FK_S_DOKUMENTY sdok on (dok.ID_S_DOKUMENTY = sdok.ID)
         and sdok.ZAANGAZOWANIE like 'Ma'
         join FK_S_STATUSY sta
         on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
         where extract(year from dok.DATA_DOK) = cast( :ROKB as Integer)  and
         extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
         not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
         join FK_S_STATUSY st on (st.ID=d.STATUS)
         where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
         and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T' and
         d.DATA_DOK >= :DATAOD and
         d.DATA_DOK <= :DATADO) and
         (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB
         from GET_JB_FROM_TYP (:TYP_JB) )) and
         dok.DATA_DOK >= :DATAOD and
         dok.DATA_DOK <= :DATADO
         and dekr.DZIAL=:DZIAL
         and dekr.ROZDZIAL=:ROZDZIAL
         and dekr.PAR=:PAR
         and dekr.PAR4=:PAR4
         group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4
         into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:ZAANGAZOWANIE;

         for select distinct dok.ID_PIERWOTNY as ID_PARENT
         from FK_DEKRETACJA dekr
         join FK_TERMINY ter
         on (dekr.ID_TERMINY = ter.ID)
         join FK_DOKUMENTY dok on (dok.ID=ter.ID_DOKUMENTY)
         join FK_S_DOKUMENTY sdok on (dok.ID_S_DOKUMENTY = sdok.ID)
         and sdok.ZAANGAZOWANIE like 'Ma'
         join FK_S_STATUSY sta
         on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
         where extract(year from dok.DATA_DOK) = cast( :ROKB as Integer)  and
         extract(year from ter.TERMIN) =cast (:ROKB as Integer) and
         not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
         join FK_S_STATUSY st on (st.ID=d.STATUS)
         where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
         and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T'  and
         d.DATA_DOK >= :DATAOD and
         d.DATA_DOK <= :DATADO) and
         (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB
         from GET_JB_FROM_TYP (:TYP_JB) )) and
         dok.DATA_DOK >= :DATAOD and
         dok.DATA_DOK <= :DATADO
         and dekr.DZIAL=:DZIAL
         and dekr.ROZDZIAL=:ROZDZIAL
         and dekr.PAR=:PAR
         and dekr.PAR4=:PAR4
         into :ID_PARENT
         do
         begin
             /* Zobowiazanie lub realizacja */
             JEST_ZAANGAZOWANIE='T';

             for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as REALIZACJA,
             sp.KOD as POZIOM
             from FK_DEKRETACJA dekr
             join FK_TERMINY ter
             on dekr.ID_TERMINY = ter.ID
             join FK_DOKUMENTY dok
             on ter.ID_DOKUMENTY = dok.ID
             join FK_S_DOKUMENTY sdok
             on dok.ID_S_DOKUMENTY = sdok.ID
             join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
             join FK_S_STATUSY sta
             on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
             where extract(year from dok.DATA_DOK) = cast (:ROKB as Integer)  and
             extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
             not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
             join FK_S_STATUSY st on (st.ID=d.STATUS)
             where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
             and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T') and
             dekr.DZIAL = :DZIAL and
             dekr.ROZDZIAL = :ROZDZIAL and
             dekr.PAR = :PAR and
             dekr.PAR4 = :PAR4 and
             dok.DATA_DOK >= :DATAOD and
             dok.DATA_DOK <= :DATADO and
             dok.ID_PARENT=:ID_PARENT
             group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sp.KOD
             into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:CZESC_REALIZACJA,:POZIOM
             do
             begin
                 if (POZIOM='REALIZACJA') then
                 REALIZACJA= REALIZACJA+ :CZESC_REALIZACJA;
             end

             for select distinct dok.ID_PIERWOTNY
             from FK_DEKRETACJA dekr
             join FK_TERMINY ter
             on dekr.ID_TERMINY = ter.ID
             join FK_DOKUMENTY dok
             on ter.ID_DOKUMENTY = dok.ID
             join FK_S_DOKUMENTY sdok
             on dok.ID_S_DOKUMENTY = sdok.ID
             join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
             join FK_S_STATUSY sta
             on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
             where extract(year from dok.DATA_DOK) = cast (:ROKB as Integer)  and
             extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
             not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
             join FK_S_STATUSY st on (st.ID=d.STATUS)
             where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
             and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T') and
             dekr.DZIAL = :DZIAL and
             dekr.ROZDZIAL = :ROZDZIAL and
             dekr.PAR = :PAR and
             dekr.PAR4 = :PAR4 and
             dok.DATA_DOK >= :DATAOD and
             dok.DATA_DOK <= :DATADO and
             dok.ID_PARENT = :ID_PARENT
             into :ID_WYZEJ
             do
             begin
                 /* Realizacja */
                for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as REALIZACJA
                from FK_DEKRETACJA dekr
                join FK_TERMINY ter
                on dekr.ID_TERMINY = ter.ID
                join FK_DOKUMENTY dok
                on ter.ID_DOKUMENTY = dok.ID
                join FK_S_DOKUMENTY sdok
                on dok.ID_S_DOKUMENTY = sdok.ID
                join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
                join FK_S_STATUSY sta
                on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
                where extract(year from dok.DATA_DOK) = cast (:ROKB as Integer)  and
                extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
                not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
                join FK_S_STATUSY st on (st.ID=d.STATUS)
                where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
                and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T') and
                sp.KOD='REALIZACJA' and
                dekr.DZIAL = :DZIAL and
                dekr.ROZDZIAL = :ROZDZIAL and
                dekr.PAR = :PAR and
                dekr.PAR4 = :PAR4 and
                dok.DATA_DOK >= :DATAOD and
                dok.DATA_DOK <= :DATADO and
                dok.ID_PARENT=:ID_WYZEJ
                group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4
                into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:CZESC_REALIZACJA
                do
                begin
                    REALIZACJA= REALIZACJA+ :CZESC_REALIZACJA;
                end
             end
         end
         suspend;
   end
end^

SET TERM ; ^

GRANT SELECT ON PB_UCHWALY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J_POZ TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_TERMINY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE WYDRUK_RB28 TO SYSDBA;

/*--------------------------------------------------------------- */

