SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES (
    id integer,
    dataod1 date,
    datado1 date,
    dataod2 date,
    datado2 date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer)
returns (
    id_dokumentu integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    wn1 double precision,
    ma1 double precision,
    wn2 double precision,
    ma2 double precision)
as
begin
    /* Okres pierwszy dokumenty */
    for select dok.ID,  dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,dekr.ID_ZADANIA
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on
    (dok.ID_S_DOKUMENTY = sdok.ID and (sdok.ZAANGAZOWANIE like 'Ma' or (sdok.ZAANGAZOWANIE like 'Wn')  ) )
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK >= :DATAOD1
      and d.DATA_DOK <= :DATADO1
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    order by  dok.ID, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA
    do
    begin
         insert into FK_RAPORT(ID, ID_DOKUMENTU, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA, POZIOM) values
         (:ID, :ID_DOKUMENTU, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA, 1);
    end

    /* Okres drugi dokumenty */
    for select dok.ID,  dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,dekr.ID_ZADANIA
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on
    (dok.ID_S_DOKUMENTY = sdok.ID and (sdok.ZAANGAZOWANIE like 'Ma' or (sdok.ZAANGAZOWANIE like 'Wn')  ) )
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK >= :DATAOD2
      and d.DATA_DOK <= :DATADO2
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    order by  dok.ID, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA
    do
    begin
         insert into FK_RAPORT(ID, ID_DOKUMENTU, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA, POZIOM) values
         (:ID, :ID_DOKUMENTU, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA, 2);
    end

    /* Okres pierwszy Konto Ma*/
    for select rp.ID_DOKUMENTU,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum (kma.KWOTA)
    from  FK_RAPORT rp
    join FK_KSIEGOWANIA kma on ( (kma.ID_DOKUMENTY=rp.ID_DOKUMENTU and (kma.ID_KONTA_MA is not null)))
    join FK_S_PLAN_KONT pl on ( pl.ID= kma.ID_KONTA_MA and pl.DZIAL= rp.DZIAL
    and pl.ROZDZIAL= rp.ROZDZIAL and pl.PAR= rp.PAR and pl.PAR4= rp.PAR4 and pl.ID_ZADANIA= rp.ID_ZADANIA)
    where rp.ID =:ID  and rp.POZIOM =1  and ROK = cast (:ROK as VARCHAR(4))
    group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :MA1
    do
    begin
        update FK_RAPORT set  BUDZET= :MA1
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and POZIOM=1 and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end
    /* Okres pierwszy Konto Wn*/
    for select rp.ID_DOKUMENTU,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum (kwn.KWOTA)
    from  FK_RAPORT rp
    join FK_KSIEGOWANIA kwn on ( (kwn.ID_DOKUMENTY=rp.ID_DOKUMENTU and (kwn.ID_KONTA_WN is not null)))
    join FK_S_PLAN_KONT pl on ( pl.ID= kwn.ID_KONTA_WN and pl.DZIAL= rp.DZIAL
    and pl.ROZDZIAL= rp.ROZDZIAL and pl.PAR= rp.PAR and pl.PAR4= rp.PAR4 and pl.ID_ZADANIA= rp.ID_ZADANIA)
    where rp.ID =:ID   and rp.POZIOM =1 and ROK = cast (:ROK as VARCHAR(4))
    group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :WN1
    do
    begin
        update FK_RAPORT set  ZAANGAZOWANIE= :WN1
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and POZIOM=1 and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end
     /* Okres drugi Konto Ma*/
    for select rp.ID_DOKUMENTU,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum (kma.KWOTA)
    from  FK_RAPORT rp
    join FK_KSIEGOWANIA kma on ( (kma.ID_DOKUMENTY=rp.ID_DOKUMENTU and (kma.ID_KONTA_MA is not null)))
    join FK_S_PLAN_KONT pl on ( pl.ID= kma.ID_KONTA_MA and pl.DZIAL= rp.DZIAL
    and pl.ROZDZIAL= rp.ROZDZIAL and pl.PAR= rp.PAR and pl.PAR4= rp.PAR4 and pl.ID_ZADANIA= rp.ID_ZADANIA)
    where rp.ID =:ID   and rp.POZIOM =2 and ROK = cast (:ROK as VARCHAR(4))
    group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :MA2
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :MA2
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and POZIOM=2 and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end
    /* Okres drugi Konto Wn*/
    for select rp.ID_DOKUMENTU,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum (kwn.KWOTA)
    from  FK_RAPORT rp
    join FK_KSIEGOWANIA kwn on ( (kwn.ID_DOKUMENTY=rp.ID_DOKUMENTU and (kwn.ID_KONTA_WN is not null)))
    join FK_S_PLAN_KONT pl on ( pl.ID= kwn.ID_KONTA_WN and pl.DZIAL= rp.DZIAL
    and pl.ROZDZIAL= rp.ROZDZIAL and pl.PAR= rp.PAR and pl.PAR4= rp.PAR4 and pl.ID_ZADANIA= rp.ID_ZADANIA)
    where rp.ID =:ID  and rp.POZIOM =2  and ROK = cast (:ROK as VARCHAR(4))
    group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :WN2
    do
    begin
        update FK_RAPORT set  REALIZACJA= :WN2
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and POZIOM=2 and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*Sumowanie dla ostatecznych wynikw*/
    for select rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum (rp.BUDZET) as MA1, sum(rp.ZAANGAZOWANIE) as WN1,
    sum(rp.ZOBOWIAZANIE) as MA2, sum(rp.REALIZACJA) as WN2
    from  FK_RAPORT rp
    where rp.ID =:ID
    group by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :MA1, :WN1,
    :MA2, :WN2
    do
    begin
        suspend;
    end



end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES TO SYSDBA;

/*--------------------------------------------------------------- */