SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ROK_NAST (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK+1 and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA,  :ZAANGAZOWANIE);
    end


    /*Zobowiazanie*/
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK+1 and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,  :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        /*Jesli dokument samodzielny to zbowiazanie  zawiera sie w  zaangazowaniu*/
        if (CZY_SAMODZIELNY= 'T') then ID_PARENT=:ID_DOKUMENTU;

        insert into FK_RAPORT(ID, ID_DOKUMENTU, ID_PARENT,  POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4, ID_ZADANIA, ZOBOWIAZANIE ) values
         (:ID, :ID_DOKUMENTU, :ID_PARENT,  2, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE);

    end

    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA,
    sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK+1 and sp.KOD='REALIZACJA' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end



    /* Wstawia zobowiazanie i realizacje do poziomu zaangazowania */
    for select rp.ID_PARENT,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum(rp.ZOBOWIAZANIE) as ZOBOWIAZANIE,   sum(rp.REALIZACJA) as REALIZACJA
    from  FK_RAPORT rp where rp.POZIOM=2 and rp.ID =:ID
    group by  rp.ID_PARENT, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE, :REALIZACJA
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :ZOBOWIAZANIE, REALIZACJA=: REALIZACJA
        where  POZIOM=1 and ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*Usuwanie dodatkowych rekordw sumujcych*/
    delete from FK_RAPORT where ID=:ID and POZIOM=2;


end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT SELECT,INSERT,DELETE,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_ROK_NAST;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ROK_NAST TO SYSDBA;

/*--------------------------------------------------------------- */