DROP PROCEDURE GET_ZAANG_KONTO;
/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_KONTO (
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    kod_z varchar(15),
    nazwa_z varchar(250),
    kwota double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    poziom varchar(15))
as
begin
    for
    select dok.NUMER, dok.DATA_DOK, dok.ID ,  dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    dekr.ID_ZADANIA, zad.KOD_Z, zad.NAZWA as NAZWA_Z, sum (dekr.KWOTA) KWOTA ,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sp.KOD as POZIOM
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on
     (dok.ID_S_DOKUMENTY = sdok.ID and (sdok.ZAANGAZOWANIE like 'Ma' or (sdok.ZAANGAZOWANIE like 'Wn')  ) )
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
    left join PB_ZADANIA zad on (zad.ID_ZADANIA=dekr.ID_ZADANIA
    and :DATADO between zad.DATAH_OD and zad.DATAH_DO and zad.ID_UCHWALY>=0 )
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group   by
    dok.NUMER, dok.DATA_DOK, dok.ID , dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    dekr.ID_ZADANIA, zad.KOD_Z, zad.NAZWA, sdok.NAZWA, pdt.NAZWA, vk.SKROT, sp.KOD

    order by  dok.ID, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    into  :NUMER, :DATA_DOK, :ID, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,
    :KOD_Z, :NAZWA_Z, :KWOTA,
    :TYP, :PODTYP, :KONTRAHENT, :POZIOM
    do
    begin
         suspend;
    end


end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_KONTO;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANG_KONTO;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_KONTO;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_KONTO TO SYSDBA;

/*--------------------------------------------------------------- */