

ALTER TABLE FK_RAPORT
ADD KOD VARCHAR(15),
ADD NAZWA VARCHAR(250);

/*--------------------------------------------------------------- */

CREATE EXCEPTION EX_PUSTY_PARAMETR 'Pusty parametr procedury';

/*--------------------------------------------------------------- */

SET TERM ^ ;

create or alter procedure GET_JB_FROM_LIST (
    JEDNOSTKI varchar(250))
returns (
    ID_JB integer,
    KOD_JB varchar(15))
as
declare variable PROCJ varchar(250);
begin
  /* Procedure Text */

  if (JEDNOSTKI = '') then
    exception EX_PUSTY_PARAMETR;


  PROCJ= 'select j.ID_JB, j.KOD_JB from PB_S_JB j  where j.ID_JB in ('||:JEDNOSTKI||') ' ;
  for EXECUTE STATEMENT :PROCJ
  into :ID_JB, :KOD_JB
  do
  suspend;
end^

SET TERM ; ^

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO SYSDBA;

/*--------------------------------------------------------------- */
SET TERM ^ ;

create or alter procedure GET_ZAANGAZOWANIE_EKSPORT (
    ID integer,
    DATAOD1 date,
    DATADO1 date,
    DATAOD2 date,
    DATADO2 date,
    JEDNOSTKI varchar(250))
returns (
    ID_JB integer,
    WN double precision,
    MA double precision,
    KOD_FULL varchar(250),
    DZIAL varchar(3),
    ROZDZIAL varchar(5),
    PAR varchar(3),
    PAR4 varchar(1),
    KOD_Z varchar(15))
as
begin
  /* Okres pierwszy */
  for  select '0' as ID_JB, 0 as WN, sum (ks.KWOTA) as MA ,
   0 as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD1 and :DATADO1)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD1 and :DATADO1 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
    insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 1, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end


  /* Okres drugi */
  for  select '0' as ID_JB, 0 as WN, -sum (ks.KWOTA) as MA ,
   0 as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD2 and :DATADO2)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD2 and :DATADO2 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
   insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 2, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end

   /* Sumowanie okresw */
   for select rp.ID_DOKUMENTU, abs(sum (rp.ZAANGAZOWANIE)), abs(sum (rp.REALIZACJA)), rp.DZIAL, rp.ROZDZIAL,
   rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   from  FK_RAPORT rp where rp.ID =:ID
   group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   into :ID_JB, :WN, :MA, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z, :KOD_FULL
   do
   begin
      suspend;
   end

    /*Usuwanie rekordw*/

   execute procedure CLEAN_RAPORT :ID;


end^

SET TERM ; ^

/* Following GRANT statetements are generated automatically */

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT SELECT,INSERT ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_EKSPORT TO SYSDBA;


/*--------------------------------------------------------------- */


SET TERM ^ ;

create or alter procedure GET_ZAANGAZOWANIE_EKSPORT_JB (
    ID integer,
    DATAOD1 date,
    DATADO1 date,
    DATAOD2 date,
    DATADO2 date,
    IN_ID_JB integer)
returns (
    ID_JB integer,
    WN double precision,
    MA double precision,
    KOD_FULL varchar(250),
    DZIAL varchar(3),
    ROZDZIAL varchar(5),
    PAR varchar(3),
    PAR4 varchar(1),
    KOD_Z varchar(15))
as
begin
  /* Okres pierwszy */
  for  select  dok.ID_JB, 0 as WN, sum (ks.KWOTA) as MA ,
  plk.KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD1 and :DATADO1)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB=:IN_ID_JB
  and (dok.data_dok between  :DATAOD1 and :DATADO1 )
  group by
  dok.ID_JB, plk.KOD_FULL,
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
    insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 1, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end


  /* Okres drugi */
  for  select  dok.ID_JB, 0 as WN, -sum (ks.KWOTA) as MA ,
  plk.KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD2 and :DATADO2)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB=:IN_ID_JB
  and (dok.data_dok between  :DATAOD2 and :DATADO2 )
  group by
  dok.ID_JB, plk.KOD_FULL,
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
   insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 2, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end

   /* Sumowanie okresw */
   for select rp.ID_DOKUMENTU, abs(sum (rp.ZAANGAZOWANIE)), abs(sum (rp.REALIZACJA)), rp.DZIAL, rp.ROZDZIAL,
   rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   from  FK_RAPORT rp where rp.ID =:ID
   group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   into :ID_JB, :WN, :MA, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z, :KOD_FULL
   do
   begin
      suspend;
   end

    /*Usuwanie rekordw*/

   execute procedure CLEAN_RAPORT :ID;


end^

SET TERM ; ^

/* Following GRANT statetements are generated automatically */

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT SELECT,INSERT ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB TO SYSDBA;


/*--------------------------------------------------------------- */

