SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_ZAANG_MIESIAC (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    ksiegowanie double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable val1 double precision;
declare variable id_dokumentu integer;
declare variable val2 double precision;
begin

    /* Wszystkie dokumenty samodzielne MA */
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.czy_samodzielny='T'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4 ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4);
    end

    /* Zaangazowanie dla aktualnej wersji aneksu */
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=1
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZAANGAZOWANIE
    do
    begin

        update FK_RAPORT r set  r.ZAANGAZOWANIE= :ZAANGAZOWANIE
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;
    end

    /* Zaangazowanie dla poprzedniej wersji aneksu */
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=1
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
   join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) -1 as WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZAANGAZOWANIE
    do
    begin
        update FK_RAPORT r set  r.BUDZET= :ZAANGAZOWANIE
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;
    end


    for select rp.ZAANGAZOWANIE, rp.BUDZET,  rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
    from  FK_RAPORT rp where  ID=:ID  and POZIOM=1
    into  :ZAANGAZOWANIE, :REALIZACJA, :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4
    do
    begin
        if (:REALIZACJA is null ) then   REALIZACJA =0.0 ;
        update FK_RAPORT  r set  r.ZAANGAZOWANIE= :ZAANGAZOWANIE - :REALIZACJA, r.BUDZET=0.0
        where  r.ID=:ID and r.ID_DOKUMENTU=:ID_DOKUMENTU and POZIOM=1 and r.DZIAL=:DZIAL
        and  r.ROZDZIAL=:ROZDZIAL and r.PAR=:PAR and r.PAR4=:PAR4;
    end

    /*Zobowiazanie dla aktualnej wersji aneksu */
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=2
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T')
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :ZOBOWIAZANIE, ID_CHILD= :ID_DOKUMENTU
        where  ID=:ID
        and ( ((:ID_PARENT is null) and (ID_DOKUMENTU=:ID_DOKUMENTU)) or ((:ID_PARENT is not null) and (ID_DOKUMENTU=:ID_PARENT)) )
        and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;

    end

    /*Zobowiazanie  dla poprzedniej wersji aneksu */
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=2
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA)-1 WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T')
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        update FK_RAPORT set  BUDZET= :ZOBOWIAZANIE ,ID_CHILD= :ID_DOKUMENTU
        where  ID=:ID
        and ( ((:ID_PARENT is null) and (ID_DOKUMENTU=:ID_DOKUMENTU)) or ((:ID_PARENT is not null) and (ID_DOKUMENTU=:ID_PARENT)) )
        and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;
    end


    for select rp.ZOBOWIAZANIE, rp.BUDZET,  rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
    from  FK_RAPORT rp where  ID=:ID
    into  :ZOBOWIAZANIE, :REALIZACJA, :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4
    do
    begin
        if (:REALIZACJA is null ) then   REALIZACJA =0.0 ;
        update FK_RAPORT  r set  r.ZOBOWIAZANIE= :ZOBOWIAZANIE - :REALIZACJA, r.BUDZET=0.0
        where  r.ID=:ID and r.ID_DOKUMENTU=:ID_DOKUMENTU and r.DZIAL=:DZIAL
        and  r.ROZDZIAL=:ROZDZIAL and r.PAR=:PAR and r.PAR4=:PAR4;
    end


    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID  and sdok.ID_S_POZIOMY=3
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T')
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :REALIZACJA
    do
    begin
        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_CHILD=:ID_PARENT and DZIAL=:DZIAL
        and  ROZDZIAL=:ROZDZIAL and PAR=:PAR and PAR4=:PAR4;
    end


     /* Zaangazowanie lata nastepne dla aktualnej wersji aneksu */
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as KSIEGOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=1
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T')
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) >:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KSIEGOWANIE
    do
    begin
        update FK_RAPORT set  KSIEGOWANIE= :KSIEGOWANIE
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;
    end


    /* Zaangazowanie lata nastepne dla poprzedniej wersji aneksu */
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as KSIEGOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma' and sdok.ID_S_POZIOMY=1
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA)-1 WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T')
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) >:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KSIEGOWANIE
    do
    begin
        update FK_RAPORT set  BUDZET= :KSIEGOWANIE
        where  ID=:ID and ID_DOKUMENTU=:ID_DOKUMENTU and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4;
    end

    for select rp.KSIEGOWANIE, rp.BUDZET,  rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
    from  FK_RAPORT rp where  ID=:ID
    into  :KSIEGOWANIE, :REALIZACJA, :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4
    do
    begin
        if (:REALIZACJA is null ) then   REALIZACJA =0.0;
        update FK_RAPORT  r set  r.KSIEGOWANIE= :KSIEGOWANIE - :REALIZACJA, r.BUDZET=0.0
        where  r.ID=:ID and r.ID_DOKUMENTU=:ID_DOKUMENTU and r.DZIAL=:DZIAL
        and  r.ROZDZIAL=:ROZDZIAL and r.PAR=:PAR and r.PAR4=:PAR4;
    end

    /*  Zwaraca ostateczne wyniki*/

    /*
    for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4,
    sum(rp.ZAANGAZOWANIE), sum(rp.ZOBOWIAZANIE), sum(rp.REALIZACJA), sum(rp.KSIEGOWANIE),
    sdok.NAZWA as TYP, sp.KOD as POZIOM
    from  FK_RAPORT rp
    join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    where rp.ID =:ID
    group by  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4,
    sdok.NAZWA, sp.KOD
    order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, sdok.NAZWA, sp.KOD
    into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4,
    :ZAANGAZOWANIE, :ZOBOWIAZANIE, :REALIZACJA, :KSIEGOWANIE, :TYP, :POZIOM
    do
    begin
       suspend;
    end

    */



    
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_MIESIAC;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_MIESIAC TO SYSDBA;

/*--------------------------------------------------------------- */