alter table FK_DOKUMENTY alter ID_PRZEPISANEGO to ID_ZRODLOWEGO;   
alter table FK_DOKUMENTY alter CZY_ID_PRZEPISANEGO_NIEPEWNE to CZY_ID_ZRODLOWEGO_NIEPEWNE;
alter table FK_DOKUMENTY alter CZY_PRZEPISANY_ZEROWANY to CZY_WYNIKOWY_ZEROWANY;

/*--------------------------------------------------------------- */

update
  FK_DOKUMENTY dokum
set
  dokum.ID_ZRODLOWEGO = null
where
  dokum.ID_ZRODLOWEGO is not null
  and (select
         dokzro.ID
       from
         FK_DOKUMENTY dokzro
       where
         dokzro.ID = dokum.ID_ZRODLOWEGO
      ) is null;

/*--------------------------------------------------------------- */

alter table FK_DOKUMENTY add constraint DOKUM_ZRODLO_FK foreign key (ID_ZRODLOWEGO) references FK_DOKUMENTY(ID) on delete set null on update cascade using index DOKUM_ZRODLO_FK_IDX;

/*--------------------------------------------------------------- */
create or alter exception DOKUMENT_ZRODLO_UNIK 'Duplikat dokumentu (ID) rdowego!';
set term ^ ;

create or alter trigger DOKUMENTY_ZRODLO_TRIGI for FK_DOKUMENTY
active before insert position 15
as
declare variable
  intCount integer;
begin
  if (new.ID_ZRODLOWEGO is not null) then begin
    select
      count(*)
    from
      FK_DOKUMENTY dokum
    where
      dokum.ID_ZRODLOWEGO = new.ID_ZRODLOWEGO
    into :intCount;
    if (intCount > 0) then exception DOKUMENT_ZRODLO_UNIK;
  end
end^

create or alter trigger DOKUMENTY_ZRODLO_TRIGU for FK_DOKUMENTY
active before update position 15
as
declare variable
  intCount integer;
begin
  if (new.ID_ZRODLOWEGO is not null) then begin
    if ((old.ID_ZRODLOWEGO is null) or (new.ID_ZRODLOWEGO <> old.ID_ZRODLOWEGO)) then begin
      select
        count(*)
      from
        FK_DOKUMENTY dokum
      where
        dokum.ID_ZRODLOWEGO = new.ID_ZRODLOWEGO
      into :intCount;
      if (intCount > 0) then exception DOKUMENT_ZRODLO_UNIK;
    end
  end
end^

set term ; ^

/*--------------------------------------------------------------- */

