
DROP PROCEDURE GET_ZAANGAZOWANIE;

/*--------------------------------------------------------------- */
SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE (
    id_zadania integer,
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    realizacja double precision,
    zaangazowanie double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1))
as
begin
  /* Zwraca zaangazowanie i realizacje na dany rok */
    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID) 
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  )) and
    dekr.DZIAL = :DZIAL and
    dekr.ROZDZIAL = :ROZDZIAL and
    dekr.PAR = :PAR and
    dekr.PAR4 = :PAR4 and
    dekr.ID_ZADANIA = :ID_ZADANIA and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY
    do
    begin
      REALIZACJA=0;
      select sum(dekr.KWOTA) as REALIZACJA
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      sp.KOD='REALIZACJA' and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dekr.ID_ZADANIA =:ID_ZADANIA and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO  and
      dok.ID_PARENT=:ID_PARENT
      group by dok.ID_PARENT
      into :REALIZACJA;

      suspend;
    end



end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE_DRP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE_DRP (
    par4_in varchar(1),
    par_in varchar(3),
    rozdzial_in varchar(5),
    dzial_in varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    realizacja double precision,
    zaangazowanie double precision,
    data_dok date,
    numer varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1))
as
begin
  /* Zwraca zaangazowanie i realizacje na dany rok */
    DZIAL=:DZIAL_IN;
    ROZDZIAL=:ROZDZIAL_IN;
    PAR=:PAR_IN;
    PAR4=:PAR4_IN;

    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    inner join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    inner join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID) 
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB
    from GET_JB_FROM_TYP (:TYP_JB) )) and
    dekr.DZIAL = :DZIAL_IN and
    dekr.ROZDZIAL = :ROZDZIAL_IN and
    dekr.PAR = :PAR_IN and
    dekr.PAR4 = :PAR4_IN and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY
    do
    begin
      REALIZACJA=0;
      select sum(dekr.KWOTA) as REALIZACJA
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on ter.ID_DOKUMENTY = dok.ID
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      sp.KOD='REALIZACJA' and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      group by dok.ID_PARENT
      into :REALIZACJA;
      suspend;
    end



end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_DRP TO SYSDBA;


/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE_DRP_GP (
    par4_in varchar(1),
    par_in varchar(3),
    rozdzial_in varchar(5),
    dzial_in varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    realizacja double precision,
    zaangazowanie double precision,
    data_dok date,
    numer varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    typ_pg char(1))
as
begin
  /* Zwraca zaangazowanie i realizacje na dany rok */
    DZIAL=:DZIAL_IN;
    ROZDZIAL=:ROZDZIAL_IN;
    PAR=:PAR_IN;
    PAR4=:PAR4_IN;

    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,
    zad.TYP_PG as TYP_PG
    from FK_DEKRETACJA dekr
    left join PB_ZADANIA zad on dekr.ID_ZADANIA = zad.ID_ZADANIA
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    inner join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    inner join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID) 
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
     not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB
    from GET_JB_FROM_TYP (:TYP_JB) )) and
    dekr.DZIAL = :DZIAL_IN and
    dekr.ROZDZIAL = :ROZDZIAL_IN and
    dekr.PAR = :PAR_IN and
    dekr.PAR4 = :PAR4_IN and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY, zad.TYP_PG
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY, :TYP_PG
    do
    begin
      REALIZACJA=0;
      select sum(dekr.KWOTA) as REALIZACJA
      from FK_DEKRETACJA dekr
      left join PB_ZADANIA zad on dekr.ID_ZADANIA = zad.ID_ZADANIA
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on ter.ID_DOKUMENTY = dok.ID
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      sp.KOD='REALIZACJA' and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT and
      zad.TYP_PG = :TYP_PG
      group by dok.ID_PARENT, zad.TYP_PG
      into :REALIZACJA;
      suspend;
    end



end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_DRP_GP TO SYSDBA;


/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ (
    id_zadania integer,
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    poziom varchar(15))
as
declare variable id_wyzej integer;
declare variable czesc_realizacja double precision;
declare variable samodzielny char(1);
declare variable czesc_zobowiazanie double precision;
begin
  /* Zwraca zaangazowanie zobowiazanie i realizacje na dany rok */
    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,sp.KOD as POZIOM
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID) 
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and

    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  )) and
    dekr.DZIAL = :DZIAL and
    dekr.ROZDZIAL = :ROZDZIAL and
    dekr.PAR = :PAR and
    dekr.PAR4 = :PAR4 and
    dekr.ID_ZADANIA =:ID_ZADANIA and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY, sp.KOD
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY,  :POZIOM

    do
    begin
      ZOBOWIAZANIE=0;
      REALIZACJA=0;
    

      if (CZY_SAMODZIELNY='T' and POZIOM='ZOBOWIAZANIE') then ZOBOWIAZANIE=:ZAANGAZOWANIE;

      for select sdok.CZY_SAMODZIELNY, sum(dekr.KWOTA) as ZOBOWIAZANIE, sp.KOD as POZIOM
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dekr.ID_ZADANIA =:ID_ZADANIA and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      group by sdok.CZY_SAMODZIELNY, dok.ID_PARENT, sp.KOD
      into :SAMODZIELNY, :CZESC_ZOBOWIAZANIE, :POZIOM
      do
      begin
          if (SAMODZIELNY='N' and POZIOM='ZOBOWIAZANIE') then
             ZOBOWIAZANIE= :ZOBOWIAZANIE+ :CZESC_ZOBOWIAZANIE;
          if (SAMODZIELNY='N' and POZIOM='REALIZACJA') then
             REALIZACJA= REALIZACJA+ :CZESC_ZOBOWIAZANIE;
      end


      for select distinct dok.ID_PIERWOTNY
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dekr.ID_ZADANIA =:ID_ZADANIA and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      into :ID_WYZEJ
      do
      begin
           select sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
           join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
           join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
           join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
           and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
           join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
           join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
           where rdok.ID_PARENT=:ID_WYZEJ and extract(year from rt.TERMIN) =:ROK
           and sp.KOD='REALIZACJA'
           and rdk.DZIAL=:DZIAL
           and rdk.ROZDZIAL=:ROZDZIAL
           and rdk.PAR=:PAR
           and rdk.PAR4=:PAR4
           and rdk.ID_ZADANIA=:ID_ZADANIA
           into :CZESC_REALIZACJA;

           if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;
           REALIZACJA=:CZESC_REALIZACJA+:REALIZACJA;
      end
      suspend;

    end

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP (
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    poziom varchar(15))
as
declare variable id_wyzej integer;
declare variable czesc_realizacja double precision;
declare variable samodzielny char(1);
declare variable czesc_zobowiazanie double precision;
begin
  /* Zwraca zaangazowanie zobowiazanie i realizacje na dany rok */
    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,sp.KOD as POZIOM
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID) 
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  )) and
    dekr.DZIAL = :DZIAL and
    dekr.ROZDZIAL = :ROZDZIAL and
    dekr.PAR = :PAR and
    dekr.PAR4 = :PAR4 and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.numer, dok.data_dok, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY,sp.KOD
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM

    do
    begin
      ZOBOWIAZANIE=0;
      REALIZACJA=0;

      if (CZY_SAMODZIELNY='T' and POZIOM='ZOBOWIAZANIE') then ZOBOWIAZANIE=:ZAANGAZOWANIE;

      for select sdok.CZY_SAMODZIELNY, sum(dekr.KWOTA) as ZOBOWIAZANIE,sp.KOD as POZIOM
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      group by sdok.CZY_SAMODZIELNY, dok.ID_PARENT, sp.KOD
      into :SAMODZIELNY, :CZESC_ZOBOWIAZANIE, :POZIOM
      do
      begin
          if (SAMODZIELNY='N' and POZIOM='ZOBOWIAZANIE') then
             ZOBOWIAZANIE= :ZOBOWIAZANIE+ :CZESC_ZOBOWIAZANIE;
          if (SAMODZIELNY='N' and POZIOM='REALIZACJA') then
             REALIZACJA= REALIZACJA+ :CZESC_ZOBOWIAZANIE;
      end

      for select distinct dok.ID_PIERWOTNY
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      into :ID_WYZEJ
      do
      begin
           select sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
           join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
           join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
           join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
           and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
           join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
           join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
           where rdok.ID_PARENT=:ID_WYZEJ and extract(year from rt.TERMIN) =:ROK
           and sp.KOD='REALIZACJA'
           and rdk.DZIAL=:DZIAL
           and rdk.ROZDZIAL=:ROZDZIAL
           and rdk.PAR=:PAR
           and rdk.PAR4=:PAR4
           into :CZESC_REALIZACJA;

           if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;
           REALIZACJA=:CZESC_REALIZACJA+:REALIZACJA;
      end
      suspend;

    end

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP (
    par4 varchar(1),
    par varchar(3),
    rozdzial varchar(5),
    dzial varchar(3),
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    czy_samodzielny char(1),
    poziom varchar(15),
    typ_pg varchar(1))
as
declare variable id_wyzej integer;
declare variable czesc_realizacja double precision;
declare variable samodzielny char(1);
declare variable czesc_zobowiazanie double precision;
begin
  /* Zwraca zaangazowanie zobowiazanie i realizacje na dany rok */
    for
    select dok.NUMER, dok.DATA_DOK, dok.ID_PIERWOTNY, sum(dekr.KWOTA) as ZAANGAZOWANIE,
    sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT,
    sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY,sp.KOD as POZIOM,
    zad.TYP_PG as TYP_PG
    from FK_DEKRETACJA dekr
    left join PB_ZADANIA zad on dekr.ID_ZADANIA = zad.ID_ZADANIA
    join FK_TERMINY ter
    on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok
    on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok
    on dok.ID_S_DOKUMENTY = sdok.ID
    and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
    left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    not EXISTS (SELECT d.ID FROM FK_DOKUMENTY  d
    join FK_S_STATUSY st on (st.ID=d.STATUS)
    where d.ID_PIERWOTNY=dok.ID_PIERWOTNY
    and d.WERSJA>dok.WERSJA and st.CZY_USUNIETY='N'
    and (st.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)) and
    d.DATA_DOK >= :DATAOD and
    d.DATA_DOK <= :DATADO) and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  )) and
    dekr.DZIAL = :DZIAL and
    dekr.ROZDZIAL = :ROZDZIAL and
    dekr.PAR = :PAR and
    dekr.PAR4 = :PAR4 and
    dok.DATA_DOK >= :DATAOD and
    dok.DATA_DOK <= :DATADO
    group by dok.numer, dok.data_dok, dok.ID_PIERWOTNY, sdok.NAZWA, pdt.NAZWA, vk.SKROT,
    sdok.CZY_SAMODZIELNY, sdok.ID_S_POZIOMY,sp.KOD, zad.TYP_PG
    order by dok.DATA_DOK

    into :NUMER, :DATA_DOK, :ID_PARENT, :ZAANGAZOWANIE, :TYP, :PODTYP, :KONTRAHENT,
    :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM, :TYP_PG

    do
    begin
      ZOBOWIAZANIE=0;
      REALIZACJA=0;

      if (CZY_SAMODZIELNY='T' and POZIOM='ZOBOWIAZANIE') then ZOBOWIAZANIE=:ZAANGAZOWANIE;

      for select sdok.CZY_SAMODZIELNY, sum(dekr.KWOTA) as ZOBOWIAZANIE,sp.KOD as POZIOM,
      zad.TYP_PG as TYP_PG
      from FK_DEKRETACJA dekr
      left join PB_ZADANIA zad on dekr.ID_ZADANIA = zad.ID_ZADANIA
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      group by sdok.CZY_SAMODZIELNY, dok.ID_PARENT, sp.KOD, zad.TYP_PG
      into :SAMODZIELNY, :CZESC_ZOBOWIAZANIE, :POZIOM, :TYP_PG
      do
      begin
          if (SAMODZIELNY='N' and POZIOM='ZOBOWIAZANIE') then
             ZOBOWIAZANIE= :ZOBOWIAZANIE+ :CZESC_ZOBOWIAZANIE;
          if (SAMODZIELNY='N' and POZIOM='REALIZACJA') then
             REALIZACJA= REALIZACJA+ :CZESC_ZOBOWIAZANIE;
      end

      for select distinct dok.ID_PIERWOTNY
      from FK_DEKRETACJA dekr
      join FK_TERMINY ter
      on dekr.ID_TERMINY = ter.ID
      join FK_DOKUMENTY dok
      on (ter.ID_DOKUMENTY = dok.ID)
      join FK_S_DOKUMENTY sdok
      on dok.ID_S_DOKUMENTY = sdok.ID
      join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
      inner join FK_S_STATUSY sta
      on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
      and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
      where extract(year from dok.DATA_DOK) = :ROK and
      extract(year from ter.TERMIN) = :ROK and
      (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB))) and
      dekr.DZIAL = :DZIAL and
      dekr.ROZDZIAL = :ROZDZIAL and
      dekr.PAR = :PAR and
      dekr.PAR4 = :PAR4 and
      dok.DATA_DOK >= :DATAOD and
      dok.DATA_DOK <= :DATADO and
      dok.ID_PARENT=:ID_PARENT
      into :ID_WYZEJ
      do
      begin
           select sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
           join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
           join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
           join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
           and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
           join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
           join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
           where rdok.ID_PARENT=:ID_WYZEJ and extract(year from rt.TERMIN) =:ROK
           and sp.KOD='REALIZACJA'
           and rdk.DZIAL=:DZIAL
           and rdk.ROZDZIAL=:ROZDZIAL
           and rdk.PAR=:PAR
           and rdk.PAR4=:PAR4
           into :CZESC_REALIZACJA;

           if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;
           REALIZACJA=:CZESC_REALIZACJA+:REALIZACJA;
      end
      suspend;

    end

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON V_KONTRAHENCI TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_PODTYPY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP TO SYSDBA;

/*--------------------------------------------------------------- */