set term ^ ;   /* 2013-12 mantis 1827 */

create or alter trigger TRIG_FK_DOKUMENTY for FK_DOKUMENTY
active before insert position 0
as
begin
  if ((new.ID is null) or (new.ID = 0)) then
    new.ID = gen_id(GEN_PB, 1);
end
^

create or alter trigger TRIGU_FK_DOKUMENTY for FK_DOKUMENTY
active before update position 0
as
begin
  if ((new.ID is null) or (new.ID = 0)) then  /* czy reagowac na "0" takze w update? */
    new.ID = gen_id(GEN_PB, 1);
end
^

set term ; ^

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

create or alter exception DUPLIKAT_NUMERU 'Duplikat numeru dokumentu!';

set term ^ ;

create or alter trigger FKDOKUMENTY_NUMER_TRIGI for FK_DOKUMENTY
active before insert position 11
as
declare variable
  intCount integer;
begin
  select
    count(*)
  from
    FK_DOKUMENTY dupl
  where
    dupl.NUMER = new.NUMER  /* nie sprawdza null - program zawsze wprowadza wartosc */
    and dupl.ID_JB = new.ID_JB
    and extract(year from dupl.DATA_DOK) = extract(year from new.DATA_DOK)  /* nie sprawdza null - program zawsze wprowadza wartosc */
    and case when dupl.ID_KONTRAHENCI is null then 0 else dupl.ID_KONTRAHENCI end = case when new.ID_KONTRAHENCI is null then 0 else new.ID_KONTRAHENCI end
  into :intCount;
  if (intCount > 0) then exception DUPLIKAT_NUMERU;
end^

create or alter trigger FK_DOKUMENTY_NUMER_TRIGU for FK_DOKUMENTY
active before update position 11
as
declare variable
  intCount integer;
begin
  if ((new.NUMER <> old.NUMER) or  /* nie sprawdza null - program zawsze wprowadza wartosc */
      (new.ID_JB <> old.ID_JB) or
      (new.DATA_DOK <> old.DATA_DOK) or  /* nie sprawdza null - program zawsze wprowadza wartosc */
      (case when new.ID_KONTRAHENCI is null then 0 else new.ID_KONTRAHENCI end <> case when old.ID_KONTRAHENCI is null then 0 else old.ID_KONTRAHENCI end)) then begin
    select
      count(*)
    from
      FK_DOKUMENTY dupl
    where
      dupl.ID <> old.ID
      and dupl.NUMER = new.NUMER
      and dupl.ID_JB = new.ID_JB
      and extract(year from dupl.DATA_DOK) = extract(year from new.DATA_DOK)
      and case when dupl.ID_KONTRAHENCI is null then 0 else dupl.ID_KONTRAHENCI end = case when new.ID_KONTRAHENCI is null then 0 else new.ID_KONTRAHENCI end
    into :intCount;
    if (intCount > 0) then exception DUPLIKAT_NUMERU;
  end
end^

set term ; ^

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */


