create table FK_S_CPV_KATEGORIA (ID bigint not null);   /* 2013-12 mantis 1791 */
alter table FK_S_CPV_KATEGORIA add constraint SCPVKATEGORIA_PK primary key (ID);

alter table FK_S_CPV_KATEGORIA add KOD char(10) character set WIN1250 not null collate PXW_PLK;
alter table FK_S_CPV_KATEGORIA add DATA_POCZ date default '01/01/2000' not null;
alter table FK_S_CPV_KATEGORIA add DATA_KONC date default '12/31/2100' not null;
alter table FK_S_CPV_KATEGORIA add NAZWA varchar(250) character set WIN1250 collate PXW_PLK;

create index SCPVKATEGORIA_KODDATY_IDX on FK_S_CPV_KATEGORIA (KOD,DATA_POCZ,DATA_KONC);

set term ^ ;
create or alter trigger SCPVKATEGORIA_ID_TRIG for FK_S_CPV_KATEGORIA
active before insert or update position 0
as
begin
  if ((new.ID is null) or (new.ID = 0)) then
    new.ID = gen_id(GEN_PB, 1);
end^
set term ; ^

alter table FK_DOKUMENTY add ID_CPV_KATEGORIA bigint;

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

create table FK_S_TRYBPRZETARG (ID bigint not null);
alter table FK_S_TRYBPRZETARG add constraint STRYBPRZET_PK primary key (ID);

alter table FK_S_TRYBPRZETARG add KOD char(10) character set win1250 not null collate pxw_plk;
alter table FK_S_TRYBPRZETARG add DATA_POCZ date default '01/01/2000' not null;
alter table FK_S_TRYBPRZETARG add DATA_KONC date default '12/31/2100' not null;
alter table FK_S_TRYBPRZETARG add NAZWA varchar(250) character set win1250 collate pxw_plk;

create index STRYBPRZET_KODDATY_IDX on FK_S_TRYBPRZETARG (KOD,DATA_POCZ,DATA_KONC);

set term ^;
create or alter trigger STRYBPRZET_ID_TRIG for FK_S_TRYBPRZETARG
active before insert or update position 0
as
begin
  if ((new.ID is null) or (new.ID = 0)) then
    new.ID = gen_id(GEN_PB, 1);
end^
set term ; ^

alter table FK_DOKUMENTY add ID_TRYBPRZETARG bigint;

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

alter table FK_DOKUMENTY add constraint DOKUM_CPVKATEG_FK foreign key (ID_CPV_KATEGORIA) references FK_S_CPV_KATEGORIA(ID) on update cascade using index DOKUM_CPVKATEG_FK_IDX;

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

alter table FK_DOKUMENTY add constraint DOKUM_TRYBPRZET_FK foreign key (ID_TRYBPRZETARG) references FK_S_TRYBPRZETARG(ID) on update cascade using index DOKUM_TRYBPRZET_FK_IDX;

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

create or alter exception BLEDNA_KOLEJNOSC_DAT 'Data pocztkowa jest pniejsza od daty kocowej!';
set term ^ ;

create or alter trigger SCPVKATEG_DATY_TRIG for FK_S_CPV_KATEGORIA
active before insert or update position 1
as
begin
  if (new.DATA_POCZ > new.DATA_KONC) then begin
    exception BLEDNA_KOLEJNOSC_DAT;
  end
end^

create or alter trigger STRYBPRZET_DATY_TRIG for FK_S_TRYBPRZETARG
active before insert or update position 1
as
begin
  if (new.DATA_POCZ > new.DATA_KONC) then begin
    exception BLEDNA_KOLEJNOSC_DAT;
  end
end^

set term ; ^

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

create or alter exception DUPLIKAT_ZAKRESU_DAT 'Duplikat okresu lub czci okresu wanoci!';
set term ^ ;

create or alter trigger SCPVKATEG_DUPL_TRIGI for FK_S_CPV_KATEGORIA
active before insert position 2
as
declare variable
  intCount integer;
begin
  select
    count (*)
  from
    FK_S_CPV_KATEGORIA s
  where
    s.KOD = new.KOD
    and s.DATA_KONC >= new.DATA_POCZ and s.DATA_POCZ <= new.DATA_KONC
  into :intCount;
  if (intCount > 0) then exception DUPLIKAT_ZAKRESU_DAT;
end^

create or alter trigger SCPVKATEG_DUPL_TRIGU for FK_S_CPV_KATEGORIA
active before update position 2
as
declare variable
  intCount integer;
begin
  if ((new.KOD <> old.KOD) or (new.DATA_POCZ <> old.DATA_POCZ) or (new.DATA_KONC <> old.DATA_KONC)) then begin
    select
      count (*)
    from
      FK_S_CPV_KATEGORIA s
    where
      s.ID <> old.ID
      and s.KOD = new.KOD
      and s.DATA_KONC >= new.DATA_POCZ and s.DATA_POCZ <= new.DATA_KONC
    into :intCount;
    if (intCount > 0) then exception DUPLIKAT_ZAKRESU_DAT;
  end
end^

create or alter trigger STRYBPRZET_DUPL_TRIGI for FK_S_TRYBPRZETARG
active before insert position 2
as
declare variable
  intCount integer;
begin
  select
    count (*)
  from
    FK_S_TRYBPRZETARG s
  where
    s.KOD = new.KOD
    and s.DATA_KONC >= new.DATA_POCZ and s.DATA_POCZ <= new.DATA_KONC
  into :intCount;
  if (intCount > 0) then exception DUPLIKAT_ZAKRESU_DAT;
end^

create or alter trigger STRYBPRZET_DUPL_TRIGU for FK_S_TRYBPRZETARG
active before update position 2
as
declare variable
  intCount integer;
begin
  if ((new.KOD <> old.KOD) or (new.DATA_POCZ <> old.DATA_POCZ) or (new.DATA_KONC <> old.DATA_KONC)) then begin
    select
      count (*)
    from
      FK_S_TRYBPRZETARG s
    where
      s.ID <> old.ID
      and s.KOD = new.KOD
      and s.DATA_KONC >= new.DATA_POCZ and s.DATA_POCZ <= new.DATA_KONC
    into :intCount;
    if (intCount > 0) then exception DUPLIKAT_ZAKRESU_DAT;
  end
end^

set term ; ^

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

create or alter exception ZMIANA_DAT_NIEMOZLIWA 'Znaleziono dokumenty niezgodne z okresem wanoci!';
set term ^ ;

create or alter trigger SCPVKATEG_DOKUM_TRIGU for FK_S_CPV_KATEGORIA
active before update position 3
as
declare variable
  intCount integer;
begin
  if ((new.DATA_POCZ <> old.DATA_POCZ) or (new.DATA_KONC <> old.DATA_KONC) or (new.ID <> old.ID)) then begin
    select
      count (*)
    from
      FK_DOKUMENTY dokum
    where
      dokum.ID_CPV_KATEGORIA = old.ID
      and dokum.DATA_DOK not between new.DATA_POCZ and new.DATA_KONC
    into :intCount;
    if (intCount > 0) then exception ZMIANA_DAT_NIEMOZLIWA;
  end
end^

create or alter trigger STRYBPRZET_DOKUM_TRIGU for FK_S_TRYBPRZETARG
active before update position 3
as
declare variable
  intCount integer;
begin
  if ((new.DATA_POCZ <> old.DATA_POCZ) or (new.DATA_KONC <> old.DATA_KONC) or (new.ID <> old.ID)) then begin
    select
      count (*)
    from
      FK_DOKUMENTY dokum
    where
      dokum.ID_TRYBPRZETARG = old.ID
      and dokum.DATA_DOK not between new.DATA_POCZ and new.DATA_KONC
    into :intCount;
    if (intCount > 0) then exception ZMIANA_DAT_NIEMOZLIWA;
  end
end^

set term ; ^

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */

insert into FK_S_CPV_KATEGORIA (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (1, 'R', '01/01/2011', '12/31/2100', 'Roboty Budowlane');
insert into FK_S_CPV_KATEGORIA (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (2, 'U', '01/01/2011', '12/31/2100', 'Usugi');
insert into FK_S_CPV_KATEGORIA (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (3, 'D', '01/01/2011', '12/31/2100', 'Dostawy');

insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (1, 'PN', '01/01/2011', '12/31/2100', 'Przetarg nieograniczony');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (2, 'ZODSZ', '01/01/2011', '12/31/2100', 'Zamwienie objte dynamicznym systemem zakupw');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (3, 'PO', '01/01/2011', '12/31/2100', 'Przetarg ograniczony');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (4, 'NzO', '01/01/2011', '12/31/2100', 'Negocjacje z ogoszeniem');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (5, 'DK', '01/01/2011', '12/31/2100', 'Dialog konkurencyjny');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (6, 'NbO', '01/01/2011', '12/31/2100', 'Negocjacje bez ogoszenia');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (7, 'ZzWR', '01/01/2011', '12/31/2100', 'Zamwienie z wolnej rki');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (8, 'ZoC', '01/01/2011', '12/31/2100', 'Zapytanie o cen');
insert into FK_S_TRYBPRZETARG (ID, KOD, DATA_POCZ, DATA_KONC, NAZWA) values (9, 'LE', '01/01/2011', '12/31/2100', 'Licytacja elektroniczna');

commit work;

/* ponizsza linia komentarza jest interpretowana przez exe jako instrukcja wykonania polecen wpisanych ponad nia: */
/*--------------------------------------------------------------- */


